#! /usr/bin/env python 
#coding=utf8

import os
import numpy as np
from matplotlib import rc, rcParams
import matplotlib.pyplot as plt
import matplotlib.ticker as ticker
from matplotlib.ticker import AutoMinorLocator

# Plot Setup {{{
rcParams['font.size'] = 14
rc('axes', linewidth=2)
rc('font', family='serif')
rc('text', usetex=True)
fig = plt.figure()
#fig.subplots_adjust(left=.15, bottom=.15, right=.95, top=.95)
ax = plt.subplot(111)
lw=1.7
ms=4
c='#2266FF'
#}}}

l=100 # plot unit
F=30
d=F/2.0
f=d*F/(d-F) # собирающая, действ
G=f/d
h=l/4
x_lens=0
y_lens=50

### Линза
ax.plot([x_lens,x_lens],[-y_lens,y_lens],'k',lw=lw)
dx=2
dy=-6
x=[x_lens,0-dx]
y=[-y_lens,-y_lens-dy]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens+dx]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens-dx]
y=[y_lens,y_lens+dy]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens+dx]
ax.plot(x,y,'k',lw=lw)

## ГОО
x=[-l,l]
y=[0,0]
ax.plot(x,y,'k',lw=lw)

## Фокусы
ax.plot(F,  0, 'ko', ms=ms)
ax.plot(-F, 0, 'ko', ms=ms)
ax.annotate('$F$', xy=(-F,-l/7))
# Двойные фокусы
ax.plot(2*F,  0, 'ko', ms=ms)
ax.plot(-2*F, 0, 'ko', ms=ms)

## Предмет
ax.arrow(-d, 0, 0, h, fc='k', ec='k', head_width=3, head_length=7, length_includes_head=True)

## Луч горизонтальный
x=[-d,0]
y=[h, h]
ax.plot(x,y,c=c)
# Преломляется
x=[0, f]
y=[h, -h*G]
k  = (y[0]-y[1]) / (x[0]-x[1])
x  = [0,        -2*f]
y  = [h+k*x[0], h+k*x[1]]
ax.plot(x,y,c=c)
# dashed part
x  = [0,      2*f]
y  = [h+k*x[0], h+k*x[1]]
ax.plot(x,y,c=c,ls='--')

## Луч через центр
x  = [-d,f]
y  = [h,-h*G]
k  = (y[0]-y[1]) / (x[0]-x[1])
x  = [-d, -2*f]
y  = [k*x[0], k*x[1]]
ax.plot(x,y,c=c)
# dashed part
x  = [-d, 2*f]
y  = [k*x[0], k*x[1]]
ax.plot(x,y,c=c,ls='--')

## Изображение
ax.arrow(f, 0, 0, -h*G, fc='orange', ec='orange', head_width=3, head_length=6, length_includes_head=True)

# Plot dosetup {{{
k=1.3
ax.set_ylim([-y_lens*k, y_lens*k])
ax.set_xlim([-l*k,      l*k])
for side in ['bottom','right','top','left']:
    ax.spines[side].set_visible(False)
ax.set_xticks([]) # labels
ax.set_yticks([])
ax.xaxis.set_ticks_position('none') # tick markers
ax.yaxis.set_ticks_position('none')
ax.set_aspect('equal')
#}}}

## Save the figure
#p = '/home/slisakov/yadisk/documents/1514/physics/8/2020_distant_lessons/10_lesson/plots/'
#f = 'lens_convex_lF_7'
#plt.savefig(p+f+'.pdf', bbox_inches='tight')
##plt.savefig(p+f+'.eps', bbox_inches='tight')
#os.system('pdftops -eps {}'.format(p+f+'.pdf'))

plt.show()
