#! /usr/bin/env python 
#coding=utf8

import os
import numpy as np
from matplotlib import rc, rcParams
import matplotlib.pyplot as plt
import matplotlib.ticker as ticker
from matplotlib.ticker import AutoMinorLocator

# Plot Setup {{{
rcParams['font.size'] = 14
rc('axes', linewidth=2)
rc('font', family='serif')
rc('text', usetex=True)
fig = plt.figure()
#fig.subplots_adjust(left=.15, bottom=.15, right=.95, top=.95)
ax = plt.subplot(111)
lw=1.7
ms=4
c='#2266FF'
#}}}

l=100 # unit
F=30
k=0.00 # y=kx
b=25
x_lens=0
y_lens=50

# ГОО
x=[-l,l]
y=[0,0]
ax.plot(x,y,'k',lw=lw)

# ДАНО
## Падающий луч
x=[-2*F, 0]
y=[b+k*x[0], b+k*x[1]]
ax.plot(x,y,c=c)
## Преломлённый луч
x = [0,        F]
y = [b+k*x[0], k*x[1]]
k2 = (y[0]-y[1]) / (x[0]-x[1])
x = [0,        2*F]
y = [b+k2*x[0], b+k2*x[1]]
ax.plot(x,y,c=c)

# Линза
ax.plot([x_lens,x_lens],[-y_lens,y_lens],'k',lw=lw)
dx=2
dy=-6
x=[x_lens,0-dx]
y=[-y_lens,-y_lens-dy]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens+dx]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens-dx]
y=[y_lens,y_lens+dy]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens+dx]
ax.plot(x,y,'k',lw=lw)

#### Параллельный падающему через центр
###x=[-2*F, 2*F]
###y=[k*x[0], k*x[1]]
###ax.plot(x,y,c=c,ls='-')

## Right Focal plane
#plt.axvline(x=F,ls='--')
# Правый фокус
ax.plot(F,  0, 'ko', ms=ms)
ax.annotate('$F$', xy=(F*1.1,-l/7))

# Параллельный преломлённому через центр
x = [-2*F,        2*F]
y = [k2*x[0], k2*x[1]]
ax.plot(x,y,c='orange',ls=':')
# Left Focal plane
plt.axvline(x=-F,ls='--', c='orange')
# Левый фокус
ax.plot(-F,  0, 'o', c='orange', ms=ms)
ax.annotate('$F$', xy=(-F*1.4,-l/7))

# Plot dosetup {{{
k=1.3
ax.set_ylim([-y_lens*k, y_lens*k])
ax.set_xlim([-l*k,      l*k])
for side in ['bottom','right','top','left']:
    ax.spines[side].set_visible(False)
ax.set_xticks([]) # labels
ax.set_yticks([])
ax.xaxis.set_ticks_position('none') # tick markers
ax.yaxis.set_ticks_position('none')
ax.set_aspect('equal')
#}}}

## Save the figure
#p = '/home/slisakov/yadisk/documents/1514/physics/8/2020_distant_lessons/10_lesson/plots/'
#f = 'predict_lens_sob_a_6'
#plt.savefig(p+f+'.pdf', bbox_inches='tight')
##plt.savefig(p+f+'.eps', bbox_inches='tight')
#os.system('pdftops -eps {}'.format(p+f+'.pdf'))

plt.show()
